---
title: ConstrainULong
slug: Web/API/ConstrainULong
tags:
  - API
  - ConstrainULong
  - Constraints
  - Dictionary
  - Interface
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - Reference
  - WebRTC
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The <strong><code>ConstrainULong</code></strong> type is used to specify a constraint for a property whose value is an integral number. It extends the {{domxref("ULongRange")}} dictionary (which provides the ability to specify a permitted range of property values) to also support an exact value and/or an ideal value the property should take on. In addition, you can specify the value as a simple long integer value, in which case the user agent does its best to match the value once all other more stringent constraints are met.</p>

<h2 id="Properties">Properties</h2>

<p><em>If the value of a <code>ConstrainULong</code> is an object rather than a number, it may have the properties below in addition to the properties it inherits from {{domxref("ULongRange")}}.</em></p>

<dl>
 <dt><code>exact</code></dt>
 <dd>An integer specifying precise, required, value the property must have to be considered acceptable.</dd>
 <dt><code>ideal</code></dt>
 <dd>An integer specifying a value the property would ideally have, but which can be considered optional if necessary to find a match.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture', '#dom-constrainulong', 'ConstrainULong')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p>Technically, <code>ConstrainULong</code> is actually based on an intermediary dictionary named <code>ConstrainULongRange</code>, which adds <code>exact</code> and <code>ideal</code> to {{domxref("ULongRange")}}, with <code>ConstrainULong</code> being a type that can be either a long integer or a <code>ULongRange</code>. However, for the sake of documentation clarity, the intermediate type (present only because of quirks in {{Glossary("WebIDL")}} syntax) is ignored here.</p>
</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ConstrainULong")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("ULongRange")}}</li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
 <li>{{domxref("MediaTrackCapabilities")}}</li>
 <li>{{domxref("MediaTrackSupportedConstraints")}}</li>
</ul>
